Project/Siteguide.Web/Controllers/EditController.cs
using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
//using System.Web.Http;
using AutoMapper;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Identity.UI.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Newtonsoft.Json.Linq;
using SiteGuide.Web.Models;
using SiteGuide.DAL.Models;
using SiteGuide.Service.Extensions;
using Newtonsoft.Json;
using System.ComponentModel.DataAnnotations;
using System.Linq.Expressions;
using System.Diagnostics.CodeAnalysis;
using System.Text;
using Humanizer;
using SiteGuide.DAL;
using SiteGuide.Service.Identifiers;
using Microsoft.Extensions.Logging;
using SiteGuide.Service;
using SiteGuide.Web.Extensions;
using SiteGuide.Service.Helpers;

namespace SiteGuide.Web.Controllers
{
    [Authorize]
    public class EditController : Controller
    {
        public const string CreateNewEditVersion = "create_new";

        private readonly SiteGuideContext _context;
        private readonly UserManager<IdentityUser> _userManager;
        private readonly EditService _editService;
        private readonly VersionChangesDescriptorService _versionChangesDescriptorService;

        public EditController(SiteGuideContext context, UserManager<IdentityUser> userManager, EditService editService, VersionChangesDescriptorService versionChangesDescriptorService)
        {
            _context = context;
            _userManager = userManager;
            _editService = editService;
            _versionChangesDescriptorService = versionChangesDescriptorService;
        }

        //private async Task ApplyChangesToModelAsync(int editId, SiteInfo model)
        //{
        //    int siteId = model.Site.Id;
        //    var editVersions = _context.EditVersion.Where(v => v.EditId == editId);
        //    var maxEditVersionNumber = editVersions.Max(v => v.EditVersionNumber);
        //    int editVersionNumber = editVersions.Single(v => v.EditVersionNumber == maxEditVersionNumber).Id; // Latest
        //    var changeToSite = await _context.Site
        //        .Include(c => c.EditVersion)
        //        .WhereEditVersion(editVersionNumber)
        //        .FirstOrDefaultAsync(c => c.Id == siteId);

        //    if (changeToSite != null)
        //        CopyRecordContent(changeToSite, model.Site);

        //    ApplyChangesToModelData(
        //        _context.Launch,
        //        model.Launches,
        //        editVersionNumber,
        //        c => c.SiteId == siteId);
        //    ApplyChangesToModelData(
        //        _context.SeeAlso,
        //        model.SeeAlsos,
        //        editVersionNumber,
        //        c => c.SiteId == siteId);
        //    ApplyChangesToModelData(
        //        _context.SiteContact,
        //        _context.SiteContact.WhereVersion().Where(c => c.SiteId == siteId).ToList(),
        //        editVersionNumber,
        //        c => c.SiteId == siteId);
        //    var siteMapshapes = _context.SiteMapshape.WhereVersion().Where(sm => sm.SiteId == siteId).ToList();
        //    ApplyChangesToModelData(
        //        _context.SiteMapshape,
        //        siteMapshapes,
        //        editVersionNumber,
        //        c => c.SiteId == siteId);
        //    ApplyChangesToModelData(
        //        _context.MapShape,
        //        _context.MapShape.Where(m => siteMapshapes.Select(sm => sm.MapshapeId).Contains(m.Id)).ToList(),
        //        editVersionNumber,
        //        c => true // Do we even need this at all? 
        //    );
        //    // TODO: etc.
        //    // Contact handled separately?

        //    model.EditId = editId;
        //    model.EditVersionNumber = editVersionNumber;
        //}

        //private void ApplyChangesToModelData<T>(
        //    DbSet<T> changes,
        //    IEnumerable<T> modelData,
        //    int editVersionNumber,
        //    Func<T, bool> changeSelector
        //    )
        //    where T : class, IRecord
        //{
        //    foreach (var change in changes
        //        .Include(c => c.EditVersion)
        //        .WhereEditVersion(editVersionNumber)
        //        .Where(c => changeSelector(c))
        //        .GroupBy(c => c.Key, (key, g) => g.OrderByDescending(c => c.EditVersion.EditVersionNumber).First()))
        //    {
        //        // Find matching data row
        //        var dataRow = modelData.SingleOrDefault(d => change.HasSameKeyAs(d));
        //        if (dataRow == null)
        //        {
        //            // TODO: If the data has been deleted, we need to handle this somehow... delete the change? Let the user and editor know?
        //            // Site has been deleted: Remove change
        //            // Contact has been deleted: Remove change
        //            // Video: Immutable?
        //            // SiteMapshape: Immutable?

        //            // TODO: If the change is an addition, add it
        //        }
        //        else
        //            CopyRecordContent(change, dataRow);
        //    }
        //}

        //private static void SetReferenceObjectsToNull<T>(T newItem) where T : class, IRecord, IId, new()
        //{
        //    // Manually set the referenced objects to null to avoid EF complaining. Keep the actual foreign key instead: E.g. AreaId instead of Area.
        //    // Should probably use viewmodels for the data passed back and forth instead.
        //    var fkProps = newItem.GetType().GetProperties().Where(
        //        prop => Attribute.IsDefined(prop, typeof(System.ComponentModel.DataAnnotations.Schema.ForeignKeyAttribute)));
        //    foreach (var fkProp in fkProps)
        //        fkProp.SetValue(newItem, null);
        //}

        //private void UpdateChanges(int editVersionId, IQueryable<Site> currentItems, List<Site> changes)
        //{
        //    // TODO

        //    //// Current item that doesn't match a change: Deletion: TODO
        //    //// Either an addition has been removed again, or an existing item has been removed:
        //    //if (currentItem == null)
        //    //{
        //    //}
        //    //else
        //    //{ }

        //    //foreach (var change in changes)
        //    //{
        //    //    var currentItem = currentItems.SingleOrDefault(s => s.Id == currentChange.Id);

        //    //    if (IsRecordContentIdentical(current.Site, change))
        //    //    {
        //    //        // Unchanged, remove change record
        //    //        if (currentChange != null)
        //    //            _context.ChangeToSite.Remove(currentChange);
        //    //    }
        //    //    else
        //    //    {
        //    //        // Site data changed, update or create site change record
        //    //        if (currentChange != null)
        //    //            UpdateChangeFromData(currentChange, change);
        //    //        else
        //    //            _context.ChangeToSite.Add(CreateChangeFromData<ChangeToSite, Site>(change, editVersionId, false));
        //    //    }
        //    //}
        //}

        //private TChange CreateChangeFromData<TChange, TData>(TData data, int editVersionId, bool isDelete) where TChange : IRecord<TChange>, new()
        //{
        //    var result = new TChange()
        //    {
        //        EditVersionId = editVersionId,
        //        IsDelete = isDelete,
        //    };
        //    UpdateChangeFromData(result, data);
        //    return result;
        //}

        //private void UpdateChangeFromData<TChange, TData>(TChange change, TData data) where TChange : IRecord<TChange>
        //{
        //    CopyStringOrValueProperties(data, change);
        //}

        //private static void CopyRecordContent<T>(T source, T target) where T : class, IRecord
        //{
        //    var ignore = typeof(IRecord).GetProperties()
        //   .Select(p => p.Name)
        //   .ToList();

        //    foreach (var propInfo in typeof(T).GetProperties(System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.Instance))
        //        if (!ignore.Contains(propInfo.Name) && propInfo.PropertyType.IsValueType || propInfo.PropertyType == "".GetType()) // Simple types only - is this what we want?
        //        {
        //            object sourceValue = propInfo.GetValue(source, null);
        //            if (propInfo != null && propInfo.CanWrite)
        //                propInfo.SetValue(target, sourceValue);
        //        }
        //}

        // TODO: Split api above into api controller

        /// <summary>
        /// List all draft edits for this user.
        /// </summary>
        public async Task<IActionResult> Drafts([FromQuery] string filter)
        {
            bool isReviews = filter?.ToUpperInvariant() == "REVIEWS"; // TODO: Split this into its own DraftReviews endpoint.

            // Get all of this user's draft edits
            var user = await _userManager.GetUserAsync(HttpContext.User);
            var editIds = _context.EditVersion
                .WhereIsDraftBy(user)
                .Where(e => isReviews
                    ? e.EditVersionNumber > 1
                    : e.EditVersionNumber == 1)
                .Select(e => e.EditId);

            var model = new DraftsListViewModel
            {
                Edits = await GetEditSummaryListItemsAsync(editIds),
                IsReviews = isReviews,
            };

            return View(model);
        }

        private async Task<IEnumerable<EditSummaryListItem>> GetEditSummaryListItemsAsync(IEnumerable<int> editIds)
        {
            var editGroups = await _context.EditVersion

Project/Siteguide.Web/Views/Versions/Compare.cshtml
@model EditVersionChangesDetails
@using SiteGuide.Service
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Helpers
@using SiteGuide.Service.Identifiers
@using SiteGuide.Web.Helpers
@using SiteGuide.DAL.Models

@{
    ViewData["Title"] = $"Edit Version {Model.ThisEdit.Id}" + $" compared to version {Model.CompareToVersion.Id}";
}

<div class="row mb-5">
    <div class="col-md-5">
        <h1>Differences between</h1>
        <div class="card">
            <h4 class="card-header">Edit @(Model.ThisEdit.EditId).@Model.ThisEdit.EditVersionNumber</h4>
            <div class="card-body">
                Status: @Model.ThisEdit.Status.Name
                @if (Model.ThisEdit.Status == EditVersionStatus.Accepted)
                {
                    <text>as version @Model.ThisEditAppliedAsVersion"</text>
                }
                @if (Model.ThisEdit.SubmittedTime != null)
                {
                    <text>on @LocalTimeHelper.LocalTime((DateTime)Model.ThisEdit.SubmittedTime)</text>
                }
                <br />
                @if (Permissions.MaySeeAuthorName(User))
                {
                    <text>Author: @Model.ThisEdit.AuthorName</text>
                    <br />
                }
                Comment: <em>@Model.ThisEdit.Comment</em>
                <br />
                Created: @LocalTimeHelper.LocalTime(Model.ThisEdit.InitialisedTime)
            </div>
        </div>
    </div>
    <div class="col-md-5">
        <h1>and</h1>
        <div class="card">
            <h4 class="card-header">Version @Model.CompareToVersion.Id</h4>
            <div class="card-body">
                Published @LocalTimeHelper.LocalTime((DateTime)Model.CompareToVersion.PublishedTime)
            </div>
        </div>
    </div>
</div>
@*<table class="table">
        <tbody>
            <tr>
                <td>Published</td>
                <td>@Model.SubmittedTime</td>
            </tr>
            <tr>
                <td>Author</td>
                <td>@Model.AuthorName</td>
            </tr>
            <tr>
                <td>
                    Role
                </td>
                <td>@Model.AuthorRole</td>
            </tr>
        </tbody>
    </table>*@

<div>
    <ChangeDetails data-node="@Model.ThisEdit.EditIdAndVersionNumber"
                   data-show-view-buttons="true"
                   data-show-edit-button="@Model.IsEditableByCurrentUser.ToString().ToLowerInvariant()" />
</div>

Project/Siteguide.Web/Views/Versions/Details.cshtml
@model VersionDetailsModel
@using SiteGuide.Service
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Identifiers
@using SiteGuide.Web.Helpers

@{
    ViewData["Title"] = $"Version {Model.ThisVersion.Id}" + ((Model.CompareToVersion == null || Model.ThisVersion.Id == Model.CompareToVersion.Id + 1) ? "" : $" compared to version {Model.CompareToVersion.Id}");
}

<div class="d-flex justify-content-between">
    <a class="btn btn-primary @(Model.PreviousVersionExists ? "" : "disabled")" role="button" aria-disabled="@(Model.PreviousVersionExists ? "false" : "true")" asp-action="Details" asp-route-id="@(Model.CompareToVersion?.Id)">Previous</a>
    <a class="btn btn-primary" asp-action="Index">Version Index</a>
    <a class="btn btn-primary @(Model.NextVersionExists ? "" : "disabled")" role="button" aria-disabled="@(Model.NextVersionExists ? "false" : "true")" asp-action="Details" asp-route-id="@(Model.ThisVersion.Id + 1)">Next</a>
</div>

@if ((Model.CompareToVersion == null || Model.ThisVersion.Id == Model.CompareToVersion.Id + 1))
{
    <div class="row">
        <div class="col">
            <br />
            <div class="float-right">
                <a class="btn btn-primary" role="button" asp-controller="Edit" asp-action="@(Model.ThisVersion.AppliedEditVersion.EditId)">View Details of Edit</a>@*TODO: May want to only show if user has access to target?*@
            </div>
            <h1>Version @Model.ThisVersion.Id:</h1>
            <h2><blockquote>@Model.ThisVersion.Comment</blockquote></h2>
        </div>
    </div>
    <partial name="./_EditVersionsSummary" for="ThisVersion.EditVersions" view-data='new ViewDataDictionary(ViewData) { { "ShowComments", true } }' />
}
else
{
    <div class="row">
        <div class="col">
            <h1>Version @Model.ThisVersion.Id compared to version @Model.CompareToVersion.Id</h1>
        </div>
    </div>
    <div class="row">
        <div class="col">
            Version @Model.ThisVersion.Id published @LocalTimeHelper.LocalTime((DateTime)Model.ThisVersion.PublishedTime)
        </div>
    </div>
    <div class="row">
        <div class="col">
            Version @Model.CompareToVersion.Id published @LocalTimeHelper.LocalTime((DateTime)Model.CompareToVersion.PublishedTime)
        </div>
    </div>
}
<br />
<br />
<div>
    <ChangeDetails data-node="@Model.ThisVersion.Id"
                   data-compare-to-version="@Model.CompareToVersion?.Id"
                   data-show-view-buttons="true" />
</div>

Project/Siteguide.Web/Views/Versions/Index.cshtml
@using SiteGuide.Web.Helpers

@{
    ViewData["Title"] = $"Version History {(Model == null ? "" : $" for {Model}")}";
}

@if (Model != null)
{
    <div class="float-right mt-2 ml-3">
        <a class="btn btn-primary btn-sm" role="button" href="/Sites/Details/@Model">Site Page</a>
    </div>
}

<h1>@ViewData["Title"]</h1>

<div>
    <VersionsList data-site="@Model" />
</div>

Project/Siteguide.Web/Views/Versions/_EditVersionsSummary.cshtml
@model IList<EditVersion>
@using SiteGuide.Service.Helpers
@using SiteGuide.Web.Controllers
@using SiteGuide.Web.Helpers
@using SiteGuide.DAL.Models
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Identifiers

<ol>
    @foreach (var editVersion in Model)
    {
        <li>
            @LocalTimeHelper.LocalTime((DateTime)editVersion.SubmittedTime)
            <partial name="_EditStatus" for="@editVersion" />
            @if (editVersion.AuthorRole != null && editVersion.AuthorRole != "Unprivileged")
            {
                <span>as </span>
                <span class="badge badge-dark">@editVersion.AuthorRole</span>
            }
            @if (Permissions.MaySeeAuthorName(User))
            {
                <text>
                    by user "@editVersion.AuthorName"
                </text>
            }
            @if ((bool)ViewData["ShowComments"] && !string.IsNullOrEmpty(editVersion.Comment))
            {
                <blockquote>@editVersion.Comment</blockquote>
            }
        </li>
    }
</ol>